## Improvements

- added isolation context

## Fixes

- fixed order executor ClosePosition for futures.
- fixed backtest order quantity check.
- fixed max kline api
- fixed optimizer limit

## Strategies

- strategy/supertrend: fixed linreg baseline slope.
- strategy/drift: added more fixes and updates
- strategy/irr: added new strategy.
- strategy/harmonic: added new harmonic shark pattern strategy.
- strategy/marketcap: reduce frequency of querying data from coinmarketcap

[Full Changelog](https://github.com/c9s/bbgo/compare/v1.41.0...main)

 - [#987](https://github.com/c9s/bbgo/pull/987): fix: supertrend-strategy: LinReg baseline slope wrongly calculated
 - [#986](https://github.com/c9s/bbgo/pull/986): fix: general order executor: ClosePosition() works on futures position
 - [#983](https://github.com/c9s/bbgo/pull/983): fix: backtest: add order quantity check
 - [#982](https://github.com/c9s/bbgo/pull/982): refactor isolation context for persistence facade configuration
 - [#981](https://github.com/c9s/bbgo/pull/981): fix optimizer limit
 - [#976](https://github.com/c9s/bbgo/pull/976): strategy: add harmonic shark pattern recognition
 - [#977](https://github.com/c9s/bbgo/pull/977): strategy: fix irr
 - [#978](https://github.com/c9s/bbgo/pull/978): refactor: refactor isolation and add more tests
 - [#979](https://github.com/c9s/bbgo/pull/979): fix: fix max kline api
 - [#974](https://github.com/c9s/bbgo/pull/974): refactor persistence for isolation
 - [#973](https://github.com/c9s/bbgo/pull/973): refactor/feature: add isolation context support
 - [#972](https://github.com/c9s/bbgo/pull/972): fix/drift_stoploss
 - [#970](https://github.com/c9s/bbgo/pull/970): refactor: extract stoploss, fix highest/lowest in trailingExit
 - [#969](https://github.com/c9s/bbgo/pull/969): fix: reduce Quantity precheck, drift condition, ewo refactor
 - [#959](https://github.com/c9s/bbgo/pull/959): stratgy: add irr
 - [#968](https://github.com/c9s/bbgo/pull/968): feature: add config dump / param dump / param modify for elliottwave
 - [#965](https://github.com/c9s/bbgo/pull/965): binance: fix futures order conversion
 - [#967](https://github.com/c9s/bbgo/pull/967): fix: wrong tag in drift
 - [#955](https://github.com/c9s/bbgo/pull/955): feature: marketcap: reduce frequency of querying data from coinmarketcap
 - [#963](https://github.com/c9s/bbgo/pull/963): feature: limit how many metrics is shown by optimizer
 - [#964](https://github.com/c9s/bbgo/pull/964): series.Filter + drift.openPosition + modify openPosition behavior + fix consts
 - [#962](https://github.com/c9s/bbgo/pull/962): fix: add rate limit on telegram api and split messages by unicode
